*python_Spssdata_add_group_percentiles.sps.
BEGIN PROGRAM.
import spss, spssdata, math
spss.Submit("GET FILE='/examples/data/Employee data.sav'.")

# Create a cursor that will only read the values of jobcat and salary
data=spssdata.Spssdata(indexes=['jobcat','salary'],accessType='w')

# Accumulate frequencies of salaries for each employment category
salaries={}; counts={}
for row in data:
   salaries[row.jobcat]=salaries.get(row.jobcat,{})
   salaries[row.jobcat][row.salary]= \ 
      salaries[row.jobcat].get(row.salary,0) + 1
   counts[row.jobcat]=counts.get(row.jobcat,0) + 1
   
# Calculate the cutpoint salary value for each percentile for each
# employment category
percentiles={}
for jobcat in salaries:
   cutpoints = [int(math.ceil(counts[jobcat]*f)) for f in [.25, .50, .75]]
   tempcount=0; pctindex=0
   percentiles[jobcat]=[]
   salarylist=sorted(salaries[jobcat].keys())
   for salary in salarylist:
      tempcount+=salaries[jobcat][salary]
      if tempcount>=cutpoints[pctindex]:
         percentiles[jobcat].append(salary)
         pctindex+=1
         if pctindex == 3:
            break
            
# Create and populate new variables for the percentiles
data.restart()
data.append(spssdata.vdef('salary_25'))
data.append(spssdata.vdef('salary_50'))
data.append(spssdata.vdef('salary_75'))
data.commitdict()
for row in data:
   data.setvalue('salary_25',percentiles[row.jobcat][0])
   data.setvalue('salary_50',percentiles[row.jobcat][1])
   data.setvalue('salary_75',percentiles[row.jobcat][2])
   data.CommitCase()
data.CClose()
end program.
