*python_add_group_percentiles.sps.
BEGIN PROGRAM.
import spss, math
spss.Submit("GET FILE='/examples/data/Employee data.sav'.")

# Create a cursor that will only read the values of jobcat and salary
cur=spss.Cursor(var=[4,5],accessType='w')
cur.AllocNewVarsBuffer(24)

# Accumulate frequencies of salaries for each employment category
salaries={}; counts={}
for i in range(spss.GetCaseCount()):
   row=cur.fetchone()
   jobcat=row[0]
   salary=row[1]
   salaries[jobcat]=salaries.get(jobcat,{})
   salaries[jobcat][salary]=salaries[jobcat].get(salary,0) + 1
   counts[jobcat]=counts.get(jobcat,0) + 1
   
# Calculate the cutpoint salary value for each percentile for each
# employment category
percentiles={}
for jobcat in salaries:
   cutpoints = [int(math.ceil(counts[jobcat]*f)) for f in [.25, .50, .75]]
   tempcount=0; pctindex=0
   percentiles[jobcat]=[]
   salarylist=sorted(salaries[jobcat].keys())
   for salary in salarylist:
      tempcount+=salaries[jobcat][salary]
      if tempcount>=cutpoints[pctindex]:
         percentiles[jobcat].append(salary)
         pctindex+=1
         if pctindex == 3:
            break
            
# Create and populate new variables for the percentiles
cur.reset()
cur.SetVarNameAndType(['salary_25','salary_50','salary_75'],[0,0,0])
cur.CommitDictionary()
for i in range(spss.GetCaseCount()):
   row=cur.fetchone()
   jobcat=row[0]
   cur.SetValueNumeric('salary_25',percentiles[jobcat][0])
   cur.SetValueNumeric('salary_50',percentiles[jobcat][1])
   cur.SetValueNumeric('salary_75',percentiles[jobcat][2])
   cur.CommitCase()
cur.close()
end program.
